/**
 * 申请贷款模板
 * @param {object} 
 * name{字段} input唯一标识 提价保存时的key 
 * title{字段汉字} input对应的label,以及验证时：title格式不正确|title不能为空
 * value{字段的值} 一般默认为'' 
 * type:{循环渲染时，不同功能的wxml} 
 * _type:{input的类型}
 * style:{证明这个数据只起到提示作用} 
 * norequeire:{在验证的时候可有可无，前提value==''}
 */
const value = [
  // 车辆和贷款信息
  [
    { name: "vmodel", title: "车型", value: '' },
    { name: "invioce", title: "车辆发票金额", reg: /(^[1-9]([0-9]+)?(\.[0-9]{1,2})?$)|(^(0){1}$)|(^[0-9]\.[0-9]([0-9])?$)/, type: 'number', _type: "number", value: '', add: '' },
    { style: 1, title: "附加品金额 （如有必填）" },
    { name: "ptax", norequire: true, title: "购置税", _title: "金额", reg: /(^[1-9]([0-9]+)?(\.[0-9]{1,2})?$)|(^(0){1}$)|(^[0-9]\.[0-9]([0-9])?$)/, type: 'number', _type: "number", value: '', add: '' },
    { name: "insurance", norequire: true, title: "保险", _title: "金额", reg: /(^[1-9]([0-9]+)?(\.[0-9]{1,2})?$)|(^(0){1}$)|(^[0-9]\.[0-9]([0-9])?$)/, type: 'number', _type: "number", value: '', add: '' },
    { name: "boutique", norequire: true, title: "精品", _title: "金额", type: 'number', _type: "number", value: '', reg: /(^[1-9]([0-9]+)?(\.[0-9]{1,2})?$)|(^(0){1}$)|(^[0-9]\.[0-9]([0-9])?$)/, add: '' },
    { name: "wextension", norequire: true, title: "延保", _title: "金额", type: 'number', _type: "number", value: '', reg: /(^[1-9]([0-9]+)?(\.[0-9]{1,2})?$)|(^(0){1}$)|(^[0-9]\.[0-9]([0-9])?$)/, add: '' },
    { name: "upkeep", norequire: true, title: "保养", _title: "金额", type: 'number', _type: "number", value: '', reg: /(^[1-9]([0-9]+)?(\.[0-9]{1,2})?$)|(^(0){1}$)|(^[0-9]\.[0-9]([0-9])?$)/, add: '' },
    { name: "lamount", title: "申请贷款金额", reg: /(^[1-9]([0-9]+)?(\.[0-9]{1,2})?$)|(^(0){1}$)|(^[0-9]\.[0-9]([0-9])?$)/, type: 'number', _type: "number", value: '', add: '' },
    { name: "dpratio", disabled: true, title: "首付比例", value: '' },
    { name: "laompany", type: "switch", title: "申请贷款产品", value: '' },
    { name: "maturity", title: "申请贷款期限", disabled: true, value: '' }
  ],
  // 申请人基本信息
  [
    { name: "name", title: "姓名", value: '' },
    // 0女 1男 
    { name: "sex", type: "switch", title: "性别", value: '' },
    //yyyy-mm-dd
    { name: "bdate", type: "picker", title: "出生日期", reg: /^\d{4}-\d{2}-\d{2}$/, value: '2000-01-01' },
    // 0本地户口 1 外地户口
    { name: "rpr", title: "户口", type: 'switch', value: '' },
    //0中国大陆（内地）1中国香港 2中国台湾 3中国澳门 4外国籍
    { name: "nationality", title: "国籍/地区", type: 'switch', value: '' },
    //0身份证 1护照 2军官证 3户口 4临时身份证 5港澳台通行证
    { name: "ntype", title: "身份证件类型", type: 'switch', value: '' },
    { name: "inumber", title: "身份证件号码", _type: "idcard", reg: /(^\d{18}$)|(^\d{17}(\d|X|x)$)/, value: '' },
    { name: "dincome", title: "税后收入", type: 'number', _type: "number", value: "", reg: /(^[1-9]([0-9]+)?(\.[0-9]{1,2})?$)|(^(0){1}$)|(^[0-9]\.[0-9]([0-9])?$)/, add: '' },
    // 0未婚 1已婚 2离异 3丧偶 4其他
    { name: "mstatus", title: "婚姻状况", type: 'switch', value: '' },
    //0高中以下 1高中 2专科 3学士 4硕士 5博士
    { name: "elevel", title: "教育程度", type: 'switch', value: "" },
    { name: "naddress", title: "现居住地址", _title: "详细门牌号", reg_msg: "请填写详细门牌号！", reg: /^.*[0-9]{1,}.*$/, value: "" },
    // 0按揭商品房 1单位房产 2全款自购商品房 3直系亲属房产 4自建房 5租赁房 6其他
    { name: "hptype", title: "现居住房产类型", type: 'switch', value: "" },
    // 0同居住地址 1同单位地址
    { name: "maddress", title: "邮寄地址", type: 'switch', value: "" },
    { name: "email", title: "电子邮箱", reg: /^\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/, value: "" },
    { name: "wx", title: "微信号", reg: /^[a-zA-Z]{1}[-_a-zA-Z0-9]{5,19}$/, value: "" },
    { name: "phone", title: "住宅固定电话", reg: /(^0?(13[0-9]|14[0-9]|15[0-9]|17[0-9]|18[0-9]|19[13589]|16[0-9])[0-9]{8}$)|(^([0-9]{3,4}-)?[0-9]{7,8}$)/, value: "" },
    { name: "tel", title: "手机号", reg: /(^0?(13[0-9]|14[0-9]|15[0-9]|17[0-9]|18[0-9]|19[13589]|16[0-9])[0-9]{8}$)|(^([0-9]{3,4}-)?[0-9]{7,8}$)/, type: 'number', _type: "number", value: "" },
    { name: "wname", title: "现工作单位名称", value: "" },
    { name: "wphone", title: "单位电话", reg: /(^0?(13[0-9]|14[0-9]|15[0-9]|17[0-9]|18[0-9]|19[13589]|16[0-9])[0-9]{8}$)|(^([0-9]{3,4}-)?[0-9]{7,8}$)/, value: "" },
    { name: "waddress", title: "现工作单位地址", _title: "详细门牌号", reg_msg: "请填写详细门牌号！", reg: /^.*[0-9]{1,}.*$/, reg_msg: "请填写详细门牌号！", value: "" },
    // 0农林牧鱼 1制造业 2批发零售 3信息传输/软件/信息技术服务 4房地产 5建筑业 6住宿/餐饮 7卫生/社会工作 8科研/技术服务 9公共管理/社会保障/社会组织 10采矿业 11文化/体育/娱乐业 12居民服务/修理/其他服务业 13租赁/商务服务业 14交通运输/仓储/邮政业 15教育 16金融 17国际组织 18电热力/燃气/水生产供应业 19水利/环境/公共设施管理 20其他
    { name: "itype", title: "行业类型", type: "switch", value: "" },
    // 0个体工商户 1私/民营企业 2公务员（政府机关正式员工）3国有企业/事业单位 4外资企业 5专业技术人员 6现代金融关联企业 7其他
    { name: "otype", title: "职业类型", type: "switch", value: "" },
    { name: "position", title: "职位", value: "" },
    // 0否 1是 
    { name: "wbst", forlen: 4, title: "是否挂靠", type: "switch", value: 0, index: 0 },
    { name: "bstname", for: 'wbst', norequire: true, title: "挂靠公司名称", value: "" },
    { name: "bstcode", for: 'wbst', norequire: true, title: "挂靠公司组织机构代码", value: "" },
    { name: "bsttel", for: 'wbst', norequire: true, title: "挂靠公司电话", reg: /(^0?(13[0-9]|14[0-9]|15[0-9]|17[0-9]|18[0-9]|19[13589]|16[0-9])[0-9]{8}$)|(^([0-9]{3,4}-)?[0-9]{7,8}$)/, value: "" },
    { name: "bstaddress", for: 'wbst', norequire: true, title: "挂靠公司地址", value: "" }
  ],

  // 紧急联系人信息
  [
    { name: "cname", title: "联系人1名称", value: "" },
    { name: "ctel", type: "number", _type: "number", title: "联系人1手机号", reg: /(^0?(13[0-9]|14[0-9]|15[0-9]|17[0-9]|18[0-9]|19[13589]|16[0-9])[0-9]{8}$)|(^([0-9]{3,4}-)?[0-9]{7,8}$)/, value: "" },
    { name: "relation", title: "联系人1与借款人关系", type: 'switch', value: "" },
    { name: "caddress", title: "联系人1现居住地址", _title: "详细门牌号", reg: /^.*[0-9]{1,}.*$/, reg_msg: "请填写详细门牌号！", value: "" },
    { name: "ctname", title: "联系人2姓名", value: "" },
    { name: "cttel", title: "联系人2手机号", type: "number", _type: "number", reg: /(^0?(13[0-9]|14[0-9]|15[0-9]|17[0-9]|18[0-9]|19[13589]|16[0-9])[0-9]{8}$)|(^([0-9]{3,4}-)?[0-9]{7,8}$)/, value: "" },
    // 是否有共借人 0没有 1有
    { name: "thesame", title: "是否有共借人", type: "switch", value: 0, index: 0 }
  ],

  // 共借人信息
  [{ name: "tsname", title: "共借人姓名", value: "" },
  { name: "tsbdate", type: "picker", title: "共借人出生日期", reg: /^\d{4}-\d{2}-\d{2}$/, value: '2000-01-01' },
  //0身份证 1护照 2军官证 3户口 4临时身份证 5港澳台通行证
  { name: "tsitype", title: "共借人身份证件类型", type: 'switch', value: '' },
  { name: "tsinumber", title: "共借人身份证件号码", _type: "idcard", reg: /(^\d{18}$)|(^\d{17}(\d|X|x)$)/, value: '' },
  { name: "tstel", title: "共借人手机号", reg: /(^0?(13[0-9]|14[0-9]|15[0-9]|17[0-9]|18[0-9]|19[13589]|16[0-9])[0-9]{8}$)|(^([0-9]{3,4}-)?[0-9]{7,8}$)/, type: 'number', _type: "number", value: "" },
  { name: "tsrelation", title: "共借人与借款人关系", type: 'switch', value: "" },
  { name: "tsnaddress", title: "共借人现居住", _title: "详细门牌号", reg: /^.*[0-9]{1,}.*$/, reg_msg: "请填写详细门牌号！", value: "" },
  // 0同居住地址 1同单位地址
  { name: "tsmaddress", title: "共借人邮寄地址", type: 'switch', value: "" },
  { name: "tsemail", title: "共借人电子邮箱", reg: /^\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/, value: "" },
  { name: "tswx", title: "共借人微信号", reg: /^[a-zA-Z]{1}[-_a-zA-Z0-9]{5,19}$/, value: "" },
  { name: "tswname", title: "共借人现工作单位名称", value: "" },
  { name: "tswphone", title: "共借人单位电话", reg: /(^0?(13[0-9]|14[0-9]|15[0-9]|17[0-9]|18[0-9]|19[13589]|16[0-9])[0-9]{8}$)|(^([0-9]{3,4}-)?[0-9]{7,8}$)/, value: "" },
  { name: "tswaddress", title: "共借人现工作单位地址", _title: "详细门牌号", reg: /^.*[0-9]{1,}.*$/, reg_msg: "请填写详细门牌号！", value: "" },
  { name: "tsmincome", title: "共借人税后月收入", type: 'number', _type: "number", value: "" }
  ]
];

// switch
const switchs = {
  sex: [{ key: 0, value: '女' }, { key: 1, value: '男' }],
  rpr: [{ key: 0, value: '本地户口' }, { key: 1, value: '外地户口' }],
  itype: [
    { key: 0, value: '农林牧鱼' },
    { key: 1, value: '制造业' },
    { key: 2, value: '批发零售' },
    { key: 3, value: '信息传输/软件/信息技术服务' },
    { key: 4, value: '房地产' },
    { key: 5, value: '建筑业' },
    { key: 6, value: '住宿/餐饮' },
    { key: 7, value: '卫生/社会工作' },
    { key: 8, value: '科研/技术服务' },
    { key: 9, value: '公共管理/社会保障/社会组织' },
    { key: 10, value: '采矿业' },
    { key: 11, value: '文化/体育/娱乐业' },
    { key: 12, value: '居民服务/修理/其他服务业' },
    { key: 13, value: '租赁/商务服务业' },
    { key: 14, value: '交通运输/仓储/邮政业' },
    { key: 15, value: '教育' },
    { key: 16, value: '金融' },
    { key: 17, value: '国际组织' },
    { key: 18, value: '电热力/燃气/水生产供应业 19水利/环境/公共设施管理' },
    { key: 19, value: '其他' }
  ],
  nationality: [
    { key: 0, value: '中国大陆（内地）' },
    { key: 1, value: '中国香港' },
    { key: 2, value: '中国台湾' },
    { key: 3, value: '中国澳门' },
    { key: 4, value: '外国籍' }
  ],
  ntype: [
    { key: 0, value: '身份证' },
    { key: 1, value: '护照' },
    { key: 2, value: '军官证' },
    { key: 3, value: '户口' },
    { key: 4, value: '临时身份证' },
    { key: 5, value: '港澳台通行证' }
  ],
  mstatus: [
    { key: 0, value: '未婚' },
    { key: 1, value: '已婚' },
    { key: 2, value: '离异' },
    { key: 3, value: '丧偶' },
    { key: 4, value: '其他' }
  ],
  elevel: [
    { key: 0, value: '高中以下' },
    { key: 1, value: '高中' },
    { key: 2, value: '专科' },
    { key: 3, value: '学士' },
    { key: 4, value: '硕士' },
    { key: 5, value: '博士' }
  ],
  hptype: [
    { key: 0, value: '按揭商品房' },
    { key: 1, value: '单位房产' },
    { key: 2, value: '全款自购商品房' },
    { key: 3, value: '直系亲属房产' },
    { key: 4, value: '自建房' },
    { key: 5, value: '租赁房' },
    { key: 6, value: '其他' }
  ],
  maddress: [{ key: 0, value: '同居住地址' }, { key: 1, value: '同单位地址' }],
  otype: [
    { key: 0, value: '个体工商户' },
    { key: 1, value: '私/民营企业' },
    { key: 2, value: '公务员（政府机关正式员工）' },
    { key: 3, value: '国有企业/事业单位' },
    { key: 4, value: '外资企业' },
    { key: 5, value: '专业技术人员' },
    { key: 6, value: '现代金融关联企业' },
    { key: 7, value: '其他' }
  ],
  wbst: [{ key: 0, value: '否' }, { key: 1, value: '是' }],
  thesame: [{ key: 0, value: '没有' }, { key: 1, value: '有' }],
  tsitype: [
    { key: 0, value: '身份证' },
    { key: 1, value: '护照' },
    { key: 2, value: '军官证' },
    { key: 3, value: '户口' },
    { key: 4, value: '临时身份证' },
    { key: 5, value: '港澳台通行证' }
  ],
  tsmaddress: [{ key: 0, value: '同居住地址' }, { key: 1, value: '同单位地址' }],
  tsrelation: [
    { key: 0, value: '配偶' },
    { key: 1, value: '父母亲' },
    { key: 2, value: '子女' },
    { key: 3, value: '其他' }
  ],
  relation: [
    { key: 0, value: '配偶' },
    { key: 1, value: '父母亲' },
    { key: 2, value: '子女' },
    { key: 3, value: '其他' }
  ]
}



// 当前时间
const date = () => {
  var date = new Date();
  return `${date.getFullYear()}-${date.getMonth()}-${date.getDate()}`;
}



module.exports = {
  value, switchs, date
};